// RenderDlgDlg.cpp : implementation file
//

#include "stdafx.h"
#include <vector>
#include <assert.h>
#include <Windows.h>
#include "RenderDlg.h"
#include "RenderDlgDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CRenderDlgDlg dialog
CRenderDlgDlg::CRenderDlgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRenderDlgDlg::IDD, pParent)
{
	m_nNewLineStaus = 0 ;
	m_pLastDrawingNode = NULL;
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRenderDlgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PICTURE, m_nCanvas);
	DDX_Control(pDX, IDC_EDIT_TEXT, m_nMyEdit);
}

BEGIN_MESSAGE_MAP(CRenderDlgDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_RENDER, &CRenderDlgDlg::OnBnClickedButtonRender)
	ON_BN_CLICKED(IDOK, &CRenderDlgDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &CRenderDlgDlg::OnBnClickedCancel)
	ON_BN_CLICKED(IDC_RADIO_SHEET, &CRenderDlgDlg::OnBnClickedRadioSheet)
	ON_BN_CLICKED(IDC_RADIO_HTML, &CRenderDlgDlg::OnBnClickedRadioHtml)
	ON_BN_CLICKED(IDC_RADIO_LINECHART, &CRenderDlgDlg::OnBnClickedRadioLinechart)
	ON_BN_CLICKED(IDC_RADIO_BARCHART, &CRenderDlgDlg::OnBnClickedRadioBarchart)
END_MESSAGE_MAP()


// CRenderDlgDlg message handlers

BOOL CRenderDlgDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	((CButton*)GetDlgItem(IDC_RADIO_HTML))->SetCheck(BST_CHECKED);
	_ResetRederStatus();
	OnBnClickedButtonRender();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRenderDlgDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

BOOL CRenderDlgDlg::PreTranslateMessage(MSG* pMsg)
{
	if( pMsg->hwnd == m_nMyEdit.GetSafeHwnd() )
	{
		if( pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_TAB )
		{
			int nPos = LOWORD(m_nMyEdit.CharFromPos(m_nMyEdit.GetCaretPos()));
			m_nMyEdit.SetSel(nPos, nPos);
			m_nMyEdit.ReplaceSel("\t", TRUE);
			return TRUE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRenderDlgDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CRect rect;
		CPaintDC dc(this);		
		m_nCanvas.GetWindowRect(&rect);
		ScreenToClient(&rect);

		dc.SetBkColor(RGB(255,255,255));
		dc.Rectangle(rect);

		if( ((CButton*)GetDlgItem(IDC_RADIO_HTML))->GetCheck() == BST_CHECKED )
		{
			_RenderHtmlText(dc , rect);
		}
		else if( ((CButton*)GetDlgItem(IDC_RADIO_SHEET))->GetCheck() == BST_CHECKED )
		{
			_RenderSheet(dc , rect);
		}
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRenderDlgDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CRenderDlgDlg::_ResetRederStatus()
{
	CString strTip , strText;
	if( ((CButton*)GetDlgItem(IDC_RADIO_HTML))->GetCheck() == BST_CHECKED )
	{
		strTip = "Simple html text parser and render. Support tag : \r\n  <p><l><b><u><ul><li>.\r\n\r\n"
			"Some exist bugs in html inline elements typesetting.";
		if( m_strHtmlText.IsEmpty() )
		{
			strText = "<b>This is a bold text.</b><l> This is a long italic\r\n"
				"text.</l></p><p>New paragraph. </p><UL><li>It\r\n"
				"em1</li><li>Item2 with <u>underline</u></li></UL>";
		}
		else
		{
			strText = m_strHtmlText;
		}

		GetDlgItem(IDC_RADIO_LINECHART)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO_BARCHART)->EnableWindow(FALSE);
	}
	else if( ((CButton*)GetDlgItem(IDC_RADIO_SHEET))->GetCheck() == BST_CHECKED )
	{
		strTip = "Simple csv sheet parser and render. "
			"Support direct edit in text window.\r\n\r\n"
			"  1. split rows by \\r\\n;\r\n"
			"  2. split columns by \\t";
		if( m_strSheetText.IsEmpty() )
		{
			strText = "\td1\td2\td3\td4\r\n"
				"s1\t3\t34\t21\t4\r\n"
				"s2\t23\t4\t7\t15\r\n"
				"s3\t12\t9\t5\t23\r\n";	
		}
		else
		{
			strText = m_strSheetText;
		}

		GetDlgItem(IDC_RADIO_LINECHART)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_BARCHART)->EnableWindow(TRUE);

		if( ((CButton*)GetDlgItem(IDC_RADIO_LINECHART))->GetCheck() == BST_CHECKED )
			CheckRadioButton(IDC_RADIO_LINECHART , IDC_RADIO_BARCHART , IDC_RADIO_LINECHART);
		else if( ((CButton*)GetDlgItem(IDC_RADIO_BARCHART))->GetCheck() == BST_CHECKED )
			CheckRadioButton(IDC_RADIO_LINECHART , IDC_RADIO_BARCHART , IDC_RADIO_BARCHART);
		else
			CheckRadioButton(IDC_RADIO_LINECHART , IDC_RADIO_BARCHART , IDC_RADIO_LINECHART);
	}

	GetDlgItem(IDC_STATIC_DESC)->SetWindowText(strTip);
	GetDlgItem(IDC_EDIT_TEXT)->SetWindowText(strText);
	OnBnClickedButtonRender();
}

HFONT CRenderDlgDlg::_CreateSpecialFont(int flags)
{
	LOGFONT font;
	font.lfHeight = 24;
	font.lfWidth = 0;
	font.lfEscapement = 0;
	font.lfOrientation = 0;
	font.lfWeight = flags & SimpleHtmlParser::nf_bold ? FW_HEAVY : FW_NORMAL;
	font.lfItalic = flags & SimpleHtmlParser::nf_italics ? TRUE : FALSE;
	font.lfUnderline = flags & SimpleHtmlParser::nf_undeline ? TRUE : FALSE;
	font.lfStrikeOut = FALSE;
	font.lfCharSet = GB2312_CHARSET;
	font.lfOutPrecision = OUT_TT_PRECIS;
	font.lfClipPrecision = CLIP_DEFAULT_PRECIS;
	font.lfQuality = CLEARTYPE_QUALITY;
	font.lfPitchAndFamily = DEFAULT_PITCH | FF_DONTCARE;
	strcpy_s(font.lfFaceName , "Times New Roman");

	return ::CreateFontIndirect(&font);
}

void CRenderDlgDlg::_RenderHtmlNode(CPaintDC& dc , const CRect& rect , SimpleHtmlParser::html_node* node , int& cur_line , int& cur_col)
{
	CRect rcCanvas = rect;
	std::string strText = node->content;
	if( strText.empty() ) return ;

	int flags = m_nHtmlParser.GetInheritAttributes(node);
	if( node->type == SimpleHtmlParser::nt_block )
	{
		cur_line += 1;
		cur_col = 0;
	}
	
	if( flags & SimpleHtmlParser::nf_li )
	{
		int tabbed_width = dc.GetTextExtent("    ").cx;
		if( node->type == SimpleHtmlParser::nt_innder )
		{
			cur_line -= 1;
		}
		else
		{
			std::string tmp = "";
			tmp += strText;
			strText = tmp;
			cur_col = tabbed_width;
		}
	}

	HFONT hFont = _CreateSpecialFont(flags);
	HGDIOBJ hOldFont = dc.SelectObject(hFont);

	std::vector<std::string> nLines;
	int cur_width = rcCanvas.Width() - cur_col;
	CSize szText = dc.GetTextExtent(strText.c_str());

	if( szText.cx < cur_width )
	{
		nLines.push_back(strText);
	}
	else
	{
		int line_begin = 0;			
		for( size_t index = 0 ; index < strText.length() ; ++index )
		{
			const char* cur_text = strText.c_str() + line_begin;
			CSize sz = dc.GetTextExtent(cur_text , index - line_begin);
			if( sz.cx > cur_width )
			{
				std::string strLine = strText.substr(line_begin , index - line_begin - 1);
				nLines.push_back(strLine);

				line_begin = index - 1;
				cur_width = rcCanvas.Width();
			}				
		}

		std::string strRest = strText.substr(line_begin , strText.length() - line_begin);
		if( !strRest.empty() ) nLines.push_back(strRest);

		int length = 0;
		for( std::vector<std::string>::iterator it = nLines.begin() ; it != nLines.end() ; ++it )
		{
			length += it->length();
		}

		assert( strText.length() == length);
	}

	for( std::vector<std::string>::iterator it = nLines.begin() ; it != nLines.end() ;)
	{
		std::string strLine = *it;
		dc.TextOut(rcCanvas.left + cur_col , rcCanvas.top + cur_line * szText.cy , strLine.c_str());			
		if( ++it == nLines.end() ) 
		{
			cur_col += dc.GetTextExtent(strLine.c_str()).cx;
			if( cur_col >= rcCanvas.Width() ) 
			{
				cur_col = 0;
				++cur_line;
			}
		}
		else 
		{
			++cur_line; 
			cur_col = 0;
		}
	}

	if( node->type == SimpleHtmlParser::nt_block || flags & SimpleHtmlParser::nf_li || flags & SimpleHtmlParser::nf_ul || flags & SimpleHtmlParser::nf_pre )
	{
		cur_line += 1;
	}

	m_pLastDrawingNode = node;
	dc.SelectObject(hOldFont);
	DeleteObject(hFont);
}

void CRenderDlgDlg::_RenderHtmlText(CPaintDC& dc , const CRect& rect)
{
	int cur_col = 0;
	int cur_line = 0;	
	CRect rcCanvas = rect;
	rcCanvas.DeflateRect(2 , 2);
	dc.SetTextCharacterExtra(3);
	dc.SetTextColor(RGB(0,0,0));	
	SimpleHtmlParser::html_node* cur = m_nHtmlParser.GetNodes();

	while(cur != NULL)
	{
		_RenderHtmlNode(dc , rcCanvas , cur , cur_line , cur_col);
		struct SimpleHtmlParser::html_node* child = cur->child;
		while(child != NULL)
		{
			_RenderHtmlNode(dc , rcCanvas , child , cur_line , cur_col);
			child = child->child;
		}	
		cur = cur->next;
	}
}

void CRenderDlgDlg::_RenderSheet(CPaintDC& dc , const CRect& rect)
{
	_RenderSheetFrame(dc , rect);
}

void CRenderDlgDlg::_RenderSheetFrame(CPaintDC& dc , const CRect& rect)
{
	int canvas_top = rect.top + 10;
	int canvas_bottom = rect.top + rect.Height() / 10 * 8;
	int canvas_height = canvas_bottom - canvas_top;
	int canvas_y_scale = canvas_height / 5;
	int canvas_left = rect.left + 30;
	int canvas_right = rect.right - 5;

	for( int i = 5 ; i > 0 ; --i )
	{
		dc.MoveTo(canvas_left , canvas_top + i * canvas_y_scale);
		dc.LineTo(canvas_right , canvas_top + i * canvas_y_scale);
	}

	StringArray nColHeaders = m_nSheetParser.GetColHeaders();
	int col_scale = (canvas_right - canvas_left) / (nColHeaders.size() + 1);
	for( size_t n = 1 ; n < (nColHeaders.size() + 1) ;  ++n)
	{
		std::string strTag = nColHeaders.at(n - 1);
		dc.TextOut(canvas_left + n * col_scale , canvas_bottom , strTag.c_str());
	}

	UINT uOldAligh = dc.GetTextAlign();
	dc.SetTextAlign( TA_TOP | TA_BASELINE);
	int max_value = m_nSheetParser.GetMaxValue();
	int chart_display_max_value = (max_value / 10 + 1) * 10;
	int chart_display_x_unit = chart_display_max_value / 4;
	for( int i = 0 ; i < 5 ; ++i )
	{
		CString strXUnit;
		strXUnit.Format("%d" , i * chart_display_x_unit);
		dc.TextOut(canvas_left - 20 , canvas_bottom - i * canvas_y_scale /*- 10*/ , strXUnit);		
	}
	dc.SetTextAlign(uOldAligh);

	int desc_y_start = canvas_bottom + 30;	
	StringArray nRowHeaders = m_nSheetParser.GetRowHeaders();
	int desc_x_start = rect.left + rect.Width() / (nRowHeaders.size() + 1);

	int color_scale_unit = 255 / (nRowHeaders.size() + 1);
	for( size_t n = 0 ; n < nRowHeaders.size() ; ++n )
	{
		CRect rcRowDesc;
		std::string strText = nRowHeaders.at(n);
		COLORREF cl = RGB(color_scale_unit * (n+1) , color_scale_unit * (n+1) , 0xFF);

		HBRUSH hBrush = CreateSolidBrush(cl);
		HGDIOBJ hOldBrush = dc.SelectObject(hBrush);
		dc.Rectangle(desc_x_start , desc_y_start , desc_x_start + 40 , desc_y_start + 10);
		dc.SelectObject(hOldBrush);
		DeleteObject(hBrush);
		desc_x_start += 40;
		dc.TextOut(desc_x_start+5 , desc_y_start  - 5, strText.c_str() , strText.length());
		desc_x_start += dc.GetTextExtent(strText.c_str() , strText.length()).cx;
		desc_x_start += 20;
	}

	int chart_left = canvas_left;
	int chart_top = canvas_top + canvas_y_scale;
	int chart_bottom = canvas_top + 5 * canvas_y_scale;
	int chart_height = chart_bottom - chart_top;	
	if( ((CButton*)GetDlgItem(IDC_RADIO_LINECHART))->GetCheck() == BST_CHECKED )
	{
		_RenderSheetChartWithLine(dc , chart_left , chart_top , chart_bottom , col_scale);	
	}
	else if( ((CButton*)GetDlgItem(IDC_RADIO_BARCHART))->GetCheck() == BST_CHECKED )
	{
		_RenderSheetChartWithRect(dc , chart_left , chart_top , chart_bottom , col_scale);
	}
}

void CRenderDlgDlg::_RenderSheetChartWithRect(CPaintDC& dc , int chart_left , int chart_top , int chart_bottom , int col_scale)
{
	int chart_height = chart_bottom - chart_top;
	int max_value = m_nSheetParser.GetMaxValue();
	int chart_display_max_value = (max_value / 10 + 1) * 10;
	int chart_display_x_unit = chart_display_max_value / 4;
	StringArray nRowHeaders = m_nSheetParser.GetRowHeaders();
	int color_scale_unit = 255 / (nRowHeaders.size() + 1);

	int total_width_per_col = nRowHeaders.size() * 15;

	for( size_t n = 0 ; n < nRowHeaders.size() ; ++n )
	{
		std::string strRow = nRowHeaders.at(n);
		std::vector<int> nValues = m_nSheetParser.GetRowValue(strRow);
		COLORREF cl = RGB(color_scale_unit * (n+1) , color_scale_unit * (n+1) , 0xFF);
		HBRUSH hBrush = CreateSolidBrush(cl);
		HGDIOBJ hOldBrush = dc.SelectObject(hBrush);

		for( size_t i = 0 ; i < nValues.size() ; ++i )
		{
			int value = nValues.at(i);
			int x = chart_left + (i + 1) * col_scale ;
			int y = chart_bottom - (int)((double)value / (double)chart_display_max_value * chart_height);

			CRect rcRectengle;			
			rcRectengle.top = y;
			rcRectengle.bottom = chart_bottom;
			rcRectengle.left = x - total_width_per_col / 2 + n * 15;
			rcRectengle.right = rcRectengle.left + 15;			
			dc.Rectangle(&rcRectengle);
		}
		dc.SelectObject(hOldBrush);
		DeleteObject(hBrush);
	}
}

void CRenderDlgDlg::_RenderSheetChartWithLine(CPaintDC& dc , int chart_left , int chart_top , int chart_bottom , int col_scale)
{
	int chart_height = chart_bottom - chart_top;
	int max_value = m_nSheetParser.GetMaxValue();
	int chart_display_max_value = (max_value / 10 + 1) * 10;
	int chart_display_x_unit = chart_display_max_value / 4;
	StringArray nRowHeaders = m_nSheetParser.GetRowHeaders();
	int color_scale_unit = 255 / (nRowHeaders.size() + 1);

	for( size_t n = 0 ; n < nRowHeaders.size() ; ++n )
	{
		std::string strRow = nRowHeaders.at(n);
		std::vector<int> nValues = m_nSheetParser.GetRowValue(strRow);
		COLORREF cl = RGB(color_scale_unit * (n+1) , color_scale_unit * (n+1) , 0xFF);
		HPEN hPen = CreatePen(PS_SOLID , 2 , cl);
		HGDIOBJ hOldPen = dc.SelectObject(hPen);

		for( size_t i = 0 ; i < nValues.size() ; ++i )
		{
			int value = nValues.at(i);
			int x = chart_left + (i + 1) * col_scale ;
			int y = chart_bottom - (int)((double)value / (double)chart_display_max_value * chart_height);
			if( i == 0 )
			{
				dc.MoveTo(x , y);
			}
			else
			{
				dc.LineTo(x , y);
			}
		}
		dc.SelectObject(hOldPen);
		DeleteObject(hPen);
	}
}

void CRenderDlgDlg::OnBnClickedButtonRender()
{
	// TODO: Add your control notification handler code here
	CString strText;
	m_pLastDrawingNode = NULL;
	GetDlgItem(IDC_EDIT_TEXT)->GetWindowText(strText);	

	if( ((CButton*)GetDlgItem(IDC_RADIO_HTML))->GetCheck() == BST_CHECKED )
	{
		m_strHtmlText = strText;
		m_nHtmlParser.ParserHtml(strText);
	}
	else if(((CButton*)GetDlgItem(IDC_RADIO_SHEET))->GetCheck() == BST_CHECKED)
	{
		m_strSheetText = strText;
		m_nSheetParser.ParseCvsText(strText);
	}

	CRect rect;
	m_nCanvas.GetWindowRect(&rect);
	ScreenToClient(&rect);
	InvalidateRect( rect );
	UpdateWindow();
}

void CRenderDlgDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	m_nHtmlParser.ReleaseNodes();
	OnOK();
}

void CRenderDlgDlg::OnBnClickedCancel()
{
	// TODO: Add your control notification handler code here
	m_nHtmlParser.ReleaseNodes();
	OnCancel();
}

void CRenderDlgDlg::OnBnClickedRadioSheet()
{
	// TODO: Add your control notification handler code here
	_ResetRederStatus();
}

void CRenderDlgDlg::OnBnClickedRadioHtml()
{
	// TODO: Add your control notification handler code here
	_ResetRederStatus();
}

void CRenderDlgDlg::OnBnClickedRadioLinechart()
{
	// TODO: Add your control notification handler code here
	_ResetRederStatus();
}

void CRenderDlgDlg::OnBnClickedRadioBarchart()
{
	// TODO: Add your control notification handler code here
	_ResetRederStatus();
}
