// RenderDlgDlg.h : header file
//

#pragma once
#include "Parser.h"
#include "afxwin.h"

// CRenderDlgDlg dialog
class CRenderDlgDlg : public CDialog
{
// Construction
public:
	CRenderDlgDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_RENDERDLG_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual BOOL CRenderDlgDlg::PreTranslateMessage(MSG* pMsg);

// Implementation
protected:
	HICON m_hIcon;
	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()	

private:
	void _ResetRederStatus();

	HFONT _CreateSpecialFont(int flags);

	void _RenderSheet(CPaintDC& dc , const CRect& rect);

	void _RenderSheetFrame(CPaintDC& dc , const CRect& rect);

	void _RenderSheetChartWithLine(CPaintDC& dc , int chart_left , int chart_top , int chart_bottom , int col_scale);

	void _RenderSheetChartWithRect(CPaintDC& dc , int chart_left , int chart_top , int chart_bottom , int col_scale);

	void _RenderHtmlText(CPaintDC& dc , const CRect& rect);

	void _RenderHtmlNode(CPaintDC& dc , const CRect& rect , SimpleHtmlParser::html_node* node , int& cur_line , int& cur_col);

private:
	CEdit m_nMyEdit;
	CStatic m_nCanvas;

	int m_nNewLineStaus;
	CString m_strHtmlText;
	CString m_strSheetText;
	SimpleCsvParser m_nSheetParser;
	SimpleHtmlParser m_nHtmlParser;	
	SimpleHtmlParser::html_node* m_pLastDrawingNode;

public:	
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCancel();
	afx_msg void OnBnClickedRadioHtml();
	afx_msg void OnBnClickedRadioSheet();	
	afx_msg void OnBnClickedButtonRender();
	afx_msg void OnBnClickedRadioBarchart();
	afx_msg void OnBnClickedRadioLinechart();	
};
